#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include "pile_ptr.h"

void print(int size,int tab[size]);
void random_tab(int size,int tab[size],int inf,int sup);
void test_ordre(int size,int array[size]);

void tri_2_pile(int size,int tab[size]);

int main(int argc,char** argv) {
   if (2 != argc) {
      return 1;
   }
   int size = atoi(argv[1]);
   int seed = atoi(argv[2]);
   srand(seed);
   int* res = malloc(size*sizeof(int));
   for (int k=0;k<20;k++) {
      random_tab(size,res,0,100);
      print(size,res);
      printf("\n");
      tri_2_pile(size,res);
      print(size,res);
      test_ordre(size,res);
      printf("\n================\n");
   }  
   return 0;  
}

bool condition(int a,int b,char* op) {
   if (strcmp(op,"<") == 0) {
      return a < b;
   } else if (strcmp(op,">=") == 0) {
      return a >= b;
   } else if (strcmp(op,"") == 0) {
      return true;
   } else {
      return false;
   }
}

void transfert(pile* pile_g,pile* pile_d,int val,char* op) {
   while (!pile_est_vide(*pile_g) 
          && condition(pile_sommet(*pile_g),val,op)) {
      pile_empiler(pile_d,pile_depiler(pile_g));
   }
}

void tri_2_pile(int size,int tab[size]) {
   pile pile_g = pile_creer(), pile_d = pile_creer();
   for (int i=0;i<size;i++) {
      transfert(&pile_g,&pile_d,tab[i],"<");
      transfert(&pile_d,&pile_g,tab[i],">=");
      pile_empiler(&pile_g,tab[i]);
   }
   transfert(&pile_d,&pile_g,0,"");
   for (int i=0;i<size;i++) {
      tab[i] = pile_depiler(&pile_g);
   }
}

void print(int size,int tab[size]) {
   for (int i=0;i<size;i++) {
      printf("%d ",tab[i]);
   }
}

void random_tab(int size,int tab[size],int inf,int sup) {
   for (int i=0;i<size;i++) {
      tab[i] = inf+rand()%(sup-inf);
   }
}

void test_ordre(int size,int array[size]) {
   for (int i=0;i<size-1;i++) {
      if (array[i] > array[i+1]) {
         printf("erreur");
         return;
      }
   }
   printf("ok");
}


